<template>
  <div>
    <crumbs title="基础术语维护" minWidth="995px" class="knowledgeTitle">
      <el-form :inline="true" class="demo-form-inline">
        <el-form-item label="医学标准术语：">
          <el-input size="mini" v-model="filter.term" placeholder="请输入术语"></el-input>
        </el-form-item>
        <el-form-item label="术语类型：">
          <el-select v-model="filter.type" clearable filterable placeholder="请选择" size="mini">
            <el-option
              v-for="item in typeList"
              :key="item.id"
              :label="item.name"
              :value="item.code"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="同义词：">
          <el-input size="mini" v-model="filter.libName" placeholder="输入同义词"></el-input>
        </el-form-item>
        <el-form-item label="状态：">
          <el-select v-model="filter.isState" clearable placeholder="请选择" size="mini">
            <el-option
              v-for="item in stateSelect"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button size="mini" @click="filterDatas">确认</el-button>
        </el-form-item>
      </el-form>
      <el-form class="secLine">
        <el-form-item>
          <el-button size="mini" type="warning" @click="addMedicalName" style="margin:0 10px">+ 新增术语</el-button>
          <el-button size="mini" @click="reloadLib">更新数据</el-button>
        </el-form-item>
      </el-form>
    </crumbs>
    <div class="contents knowledgeContents">
      <el-table :data="list" border style="width: 100%">
        <el-table-column type="index" :index="indexMethod" label="编号" width="60"></el-table-column>
        <el-table-column prop="libName" label="医学标准术语" show-overflow-tooltip></el-table-column>
        <el-table-column prop="typeName" label="术语类型"></el-table-column>
        <el-table-column prop="synonymName" label="同义词" show-overflow-tooltip></el-table-column>
        <el-table-column label="状态" width="100">
          <template slot-scope="scope">
            <span>{{scope.row.isDeleted == 'N'?'启用':'禁用'}}</span>
          </template>
        </el-table-column>
        <el-table-column prop="modifierName" label="操作人"></el-table-column>
        <el-table-column prop="gmtModified" label="操作时间" :show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="操作" width="160">
          <template slot-scope="scope">
            <el-button type="text" size="small" @click="toEditProduct(scope.row)">修改</el-button>
            <span style="margin:0 3px;">|</span>
            <el-button type="text" size="small" @click="toEditProduct(scope.row,true)">复制</el-button>
            <span style="margin:0 3px;">|</span>
            <el-button
              type="text"
              size="small"
              :class="scope.row.isDeleted == 'N'?'delete':'review'"
              @click="showDelDialog(scope.row)"
            >{{scope.row.isDeleted == 'Y'?'启用':'禁用'}}</el-button>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination
        :current-page.sync="currentPage"
        @current-change="currentChange"
        background
        :page-size="pageSize"
        :page-sizes="pageSizeArr"
        @size-change="handleSizeChange"
        :layout="pageLayout"
        :total="total"
      ></el-pagination>
    </div>
  </div>
</template>

<script>
import api from '@api/knowledgeTree.js';
import config from '@api/config.js';
import utils from '@api/utils.js';

export default {
  name: 'BasicTermsMaintenance',
  data: function() {
    return {
      list: [],
      stateSelect: [
        { id: 'N', name: '启用' },
        { id: 'Y', name: '禁用' }
      ],
      // isState:'',
      cacheData: {}, //因为删除和恢复要及时更新，所以不做缓存
      currentPage: 1,
      pageSize: config.pageSize,
      pageSizeArr: config.pageSizeArr,
      pageLayout: config.pageLayout,
      total: 0,
      searched: false,
      filter: {
        term: '',
        type: '',
        libName: ''
      },
      typeList: [],
      reloadFlag: true
    };
  },
  created() {
    const param = this.$route.params;
    if (param.currentPage) {
      this.inCurrentPage = param.currentPage;
    }
    if (param.filter) {
      this.filter = param.filter;
    }

    this.getTypeList();
    //返回时避免参数未赋值就获取列表
    this.$nextTick(() => {
      this.getDataList();
    });
  },
  watch: {
    filter: {
      handler: function() {
        this.searched = false;
      },
      deep: true
    }
  },
  // beforeRouteEnter(to, from, next) {
  //   next(vm => {
  //     //const pm = to.param;
  //     Object.assign(vm, to.params);
  //     vm.inCurrentPage = to.params.currentPage;
  //   });
  // },
  methods: {
    handleSizeChange(val) {
      this.pageSize = val;
      this.currentPage = utils.getCurrentPage(
        this.currentPage,
        this.total,
        this.pageSize
      );
      this.getDataList();
    },
    reloadLib() {
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      });
      if (this.reloadFlag) {
        this.reloadFlag = false;
        api.clearStandRuleDrug().then(res => {
          this.getDataList();
          if (res.data.code == 0) {
            this.reloadFlag = true;
            this.warning('更新成功', 'success');
          } else {
            this.warning(res.data.msg || '更新失败，请重试');
          }
        });
      }
    },
    addMedicalName() {
      const pam = this.searched
        ? {
            currentPage: this.currentPage,
            pageSize: this.pageSize,
            filter: this.filter
          }
        : { currentPage: this.currentPage, pageSize: this.pageSize };
      this.$router.push({ name: 'AddTerm', params: pam });
    },
    toEditProduct(row, copy) {
      const pam = this.searched
        ? {
            currentPage: this.currentPage,
            pageSize: this.pageSize,
            filter: this.filter
          }
        : { currentPage: this.currentPage, pageSize: this.pageSize };
      this.$router.push({
        name: 'AddTerm',
        // params: {info:row}
        params: Object.assign(pam, { id: row.conceptId,libType:row.libType, copy: copy })
      });
    },
    filterDatas() {
      this.currentPage = 1;
      this.getDataList();
    },
    getDataList(isTurnPage) {
      const param = this.getFilterItems(isTurnPage);
      this.searched = true;
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      });
      api
        .getBaseConceptInfoPage(param)
        .then(res => {
          loading.close();
          if (res.data.code == '0') {
            const data = res.data.data;
            const templis = data.records;
            for (let i = 0; i < templis.length; i++) {
              templis[i].isDeleted = templis[i].status == '1' ? 'N' : 'Y';
            }
            this.list = templis;
            // this.cacheData[param.current] = data.records;
            this.total = data.total;
            if (this.inCurrentPage !== undefined) {
              this.currentPage = this.inCurrentPage;
              this.inCurrentPage = undefined;
            }
          }
        })
        .catch(error => {
          console.log(error);
        });
    },
    getTypeList() {
      api
        .baseTypeGetPage({ name: '', size: 1000 })
        .then(res => {
          const data = res.data;
          if (data.code == 0) {
            this.typeList = data.data.records || [];
          } else {
            console.log(res.msg);
          }
        })
        .catch(error => {
          console.log(error);
        });
    },
    /*getDetailList(id) {
        this.$router.push({name:'DeptInfoDetail', params:{id: id}})
      },*/
    getFilterItems(isTurnPage) {
      //翻页时筛选条件没点确定则清空
      if (isTurnPage && !this.searched) {
        this.clearFilter();
      }
      const param = {
        libName: this.filter.term.trim(),
        libType: this.filter.type,
        status:
          this.filter.isState == 'N'
            ? '1'
            : this.filter.isState == 'Y'
            ? '0'
            : '',
        synonymName: this.filter.libName.trim(),
        current: this.inCurrentPage || this.currentPage,
        size: this.pageSize,
        isDeleted: this.filter.isState
      };
      return param;
    },
    indexMethod(index) {
      return (this.currentPage - 1) * this.pageSize + index + 1;
    },
    currentChange(next) {
      this.currentPage = next;
      // if (this.cacheData[next]) {       //如果已请求过该页数据，则使用缓存不重复请求
      //   this.list = this.cacheData[next];
      // } else {
      this.getDataList(true);
      // }
    },
    warning(msg, type) {
      this.$message({
        showClose: true,
        message: msg,
        type: type || 'warning'
      });
    },
    showConfirmDialog(msg, resolve) {
      this.$alert(msg, '提示', {
        confirmButtonText: '确定',
        type: 'warning'
      })
        .then(() => {
          resolve();
        })
        .catch(() => {});
    },
    showDelDialog(item) {
      /*const param = {
          term:item.term,
          type:item.type,
          id:item.id
        }*/
      const param = {
        conceptId: item.conceptId
      };
      let url = item.isDeleted === 'N' ? 'disableConcept' : 'startConcept';
      let waringTxt =
        item.isDeleted === 'N'
          ? '是否禁用该标准术语？'
          : '是否重新启用该条数据？';
      this.showConfirmDialog(waringTxt, () => {
        api[url](param)
          .then(res => {
            if (res.data.code == '0') {
              if (!this.searched) {
                //未点确认时清空搜索条件
                this.clearFilter();
              }
              if (item.isDeleted !== 'N') {
                //恢复成功后跳转到筛选条件的首页
                this.currentPage = 1;
              } else {
                if (this.filter.isState !== '' && this.list.length === 1) {
                  //有启用状态筛选条件且当前页只有最后一条数据删除时，删除成功后跳转到前一页
                  this.currentPage =
                    this.currentPage === 1 ? 1 : this.currentPage - 1;
                }
              }
              this.warning(res.data.msg || '操作成功', 'success');
              this.getDataList();
            } else {
              this.warning(res.data.msg);
            }
          })
          .catch(error => {
            this.warning(error);
          });
      });
    },
    clearFilter() {
      this.filter = {
        term: '',
        type: '',
        libName: '',
        isState: ''
      };
    }
  }
};
</script>

<style lang="less" scoped>
@import '../../less/admin.less';
/deep/ .container.knowledgeTitle {
  height: 80px;
}
/deep/ .contents.knowledgeContents {
  padding: 104px 20px 0;
}
/deep/ .secLine.el-form {
  float: right;
  display: block;
  position: relative;
  top: -5px;
}
.delete {
  color: red;
}
.review {
  color: #22ccc8;
}
.deletes {
  cursor: default;
  color: red;
}
.reviews {
  color: #606266;
  cursor: default;
}
.el-table .cell {
  overflow: hidden;
  white-space: nowrap;
}
#upFile {
  display: none !important;
}
</style>